
_interrupt:

;ballisticchronograph.mbas,148 :: 		dim tmr0L_save   as byte
;ballisticchronograph.mbas,150 :: 		if INT0IF_bit then  '---- 1st screen
	BTFSS       INT0IF_bit+0, BitPos(INT0IF_bit+0) 
	GOTO        L__interrupt2
;ballisticchronograph.mbas,151 :: 		if INT0IE_bit = INTERRUPT_ENABLE then
	BTFSS       INT0IE_bit+0, BitPos(INT0IE_bit+0) 
	GOTO        L__interrupt5
;ballisticchronograph.mbas,152 :: 		TMR1H = 0
	CLRF        TMR1H+0 
;ballisticchronograph.mbas,153 :: 		TMR1L = 0
	CLRF        TMR1L+0 
;ballisticchronograph.mbas,154 :: 		TMR0H = 0
	CLRF        TMR0H+0 
;ballisticchronograph.mbas,155 :: 		TMR0L = 0
	CLRF        TMR0L+0 
;ballisticchronograph.mbas,156 :: 		tmr1_oveflow_count = 0
	CLRF        _tmr1_oveflow_count+0 
;ballisticchronograph.mbas,157 :: 		INT0IE_bit  = INTERRUPT_DISABLE
	BCF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,158 :: 		INT2IF_bit  = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,159 :: 		INT2IE_bit  = INTERRUPT_ENABLE
	BSF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,160 :: 		screen1st_detect = True
	MOVLW       255
	MOVWF       _screen1st_detect+0 
;ballisticchronograph.mbas,161 :: 		timeout_counter = 0
	CLRF        _timeout_counter+0 
;ballisticchronograph.mbas,162 :: 		screen_timeout = False
	CLRF        _screen_timeout+0 
	GOTO        L__interrupt6
;ballisticchronograph.mbas,163 :: 		else
L__interrupt5:
;ballisticchronograph.mbas,164 :: 		if shotgun_mode = False then
	MOVF        _shotgun_mode+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt8
;ballisticchronograph.mbas,165 :: 		pulse_error = True
	MOVLW       255
	MOVWF       _pulse_error+0 
L__interrupt8:
;ballisticchronograph.mbas,167 :: 		end if
L__interrupt6:
;ballisticchronograph.mbas,168 :: 		INT0IF_bit  = FLAG_CLEAR
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
	GOTO        L__interrupt3
;ballisticchronograph.mbas,169 :: 		else  '---- 2nd screen
L__interrupt2:
;ballisticchronograph.mbas,170 :: 		nop
	NOP
;ballisticchronograph.mbas,171 :: 		tmr1L_save = TMR1L
	MOVF        TMR1L+0, 0 
	MOVWF       _tmr1L_save+0 
;ballisticchronograph.mbas,172 :: 		tmr1H_save = TMR1H
	MOVF        TMR1H+0, 0 
	MOVWF       _tmr1H_save+0 
;ballisticchronograph.mbas,173 :: 		INT2IE_bit = INTERRUPT_DISABLE
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,174 :: 		tmr0L_save = TMR0L
	MOVF        TMR0L+0, 0 
	MOVWF       R6 
;ballisticchronograph.mbas,175 :: 		tmr0H_save = TMR0H
	MOVF        TMR0H+0, 0 
	MOVWF       R5 
;ballisticchronograph.mbas,176 :: 		if tmr1H_save = 0x00 then
	MOVF        _tmr1H_save+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt11
;ballisticchronograph.mbas,177 :: 		tmr0_count = tmr0H_save * 0x100 + tmr0L_save
	MOVF        R5, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R6, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
;ballisticchronograph.mbas,178 :: 		tmr1_oveflow_count_save = (tmr0_count + 128 ) >> 8
	MOVLW       128
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmr1_oveflow_count_save+0 
	GOTO        L__interrupt12
;ballisticchronograph.mbas,179 :: 		else
L__interrupt11:
;ballisticchronograph.mbas,180 :: 		tmr1_oveflow_count_save = tmr1_oveflow_count
	MOVF        _tmr1_oveflow_count+0, 0 
	MOVWF       _tmr1_oveflow_count_save+0 
;ballisticchronograph.mbas,181 :: 		end if
L__interrupt12:
;ballisticchronograph.mbas,182 :: 		if pulse_error = False then
	MOVF        _pulse_error+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt14
;ballisticchronograph.mbas,183 :: 		screen2nd_detect = True
	MOVLW       255
	MOVWF       _screen2nd_detect+0 
L__interrupt14:
;ballisticchronograph.mbas,185 :: 		INT2IF_bit = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,186 :: 		end if
L__interrupt3:
;ballisticchronograph.mbas,187 :: 		end sub
L_end_interrupt:
L__interrupt336:
	RETFIE      1
; end of _interrupt

_interrupt_low:
	MOVWF       ___Low_saveWREG+0 
	MOVF        STATUS+0, 0 
	MOVWF       ___Low_saveSTATUS+0 
	MOVF        BSR+0, 0 
	MOVWF       ___Low_saveBSR+0 

;ballisticchronograph.mbas,190 :: 		sub procedure interrupt_low
;ballisticchronograph.mbas,192 :: 		if TMR1IF_bit then
	BTFSS       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L__interrupt_low18
;ballisticchronograph.mbas,193 :: 		tmr1_oveflow_count = tmr1_oveflow_count + 1
	INCF        _tmr1_oveflow_count+0, 1 
;ballisticchronograph.mbas,194 :: 		TMR1IF_bit = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
L__interrupt_low18:
;ballisticchronograph.mbas,198 :: 		if TMR2IF_bit then
	BTFSS       TMR2IF_bit+0, BitPos(TMR2IF_bit+0) 
	GOTO        L__interrupt_low21
;ballisticchronograph.mbas,200 :: 		if sw_enable = false then
	MOVF        _sw_enable+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low24
;ballisticchronograph.mbas,201 :: 		if (SW1_PORT + SW2_PORT + SW3_PORT) = 3 then  ' switch released
	CLRF        R1 
	BTFSC       PORTA+0, 3 
	INCF        R1, 1 
	CLRF        R0 
	BTFSC       PORTB+0, 4 
	INCF        R0, 1 
	MOVF        R0, 0 
	ADDWF       R1, 1 
	CLRF        R0 
	BTFSC       PORTA+0, 1 
	INCF        R0, 1 
	MOVF        R0, 0 
	ADDWF       R1, 1 
	MOVF        R1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low27
;ballisticchronograph.mbas,202 :: 		if 0 < sw_off_counter then
	MOVLW       0
	MOVWF       R0 
	MOVF        _sw_off_counter+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low339
	MOVF        _sw_off_counter+0, 0 
	SUBLW       0
L__interrupt_low339:
	BTFSC       STATUS+0, 0 
	GOTO        L__interrupt_low30
;ballisticchronograph.mbas,203 :: 		sw_off_counter = sw_off_counter - 1
	MOVLW       1
	SUBWF       _sw_off_counter+0, 1 
	MOVLW       0
	SUBWFB      _sw_off_counter+1, 1 
L__interrupt_low30:
;ballisticchronograph.mbas,204 :: 		end if
	GOTO        L__interrupt_low28
;ballisticchronograph.mbas,205 :: 		else                             ' switch pressed
L__interrupt_low27:
;ballisticchronograph.mbas,206 :: 		sw_off_counter = SW_BOUNCE_TIME
	MOVLW       30
	MOVWF       _sw_off_counter+0 
	MOVLW       0
	MOVWF       _sw_off_counter+1 
;ballisticchronograph.mbas,207 :: 		sw_enable = false
	CLRF        _sw_enable+0 
;ballisticchronograph.mbas,208 :: 		end if
L__interrupt_low28:
L__interrupt_low24:
;ballisticchronograph.mbas,210 :: 		if sw_off_counter = 0 then
	MOVLW       0
	XORWF       _sw_off_counter+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low340
	MOVLW       0
	XORWF       _sw_off_counter+0, 0 
L__interrupt_low340:
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low33
;ballisticchronograph.mbas,211 :: 		sw_enable = true
	MOVLW       255
	MOVWF       _sw_enable+0 
L__interrupt_low33:
;ballisticchronograph.mbas,215 :: 		if screen1st_detect then
	MOVF        _screen1st_detect+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__interrupt_low36
;ballisticchronograph.mbas,216 :: 		timeout_counter = timeout_counter + 1
	INCF        _timeout_counter+0, 1 
;ballisticchronograph.mbas,217 :: 		if timeout_counter = SCREEN2_TIMEOUT_COUNT then
	MOVF        _timeout_counter+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt_low39
;ballisticchronograph.mbas,218 :: 		screen_timeout = True
	MOVLW       255
	MOVWF       _screen_timeout+0 
L__interrupt_low39:
;ballisticchronograph.mbas,219 :: 		end if
L__interrupt_low36:
;ballisticchronograph.mbas,223 :: 		interval_counter = interval_counter + 1
	MOVLW       1
	ADDWF       _interval_counter+0, 1 
	MOVLW       0
	ADDWFC      _interval_counter+1, 1 
	ADDWFC      _interval_counter+2, 1 
	ADDWFC      _interval_counter+3, 1 
L__interrupt_low21:
;ballisticchronograph.mbas,226 :: 		TMR2IF_bit = FLAG_CLEAR
	BCF         TMR2IF_bit+0, BitPos(TMR2IF_bit+0) 
;ballisticchronograph.mbas,227 :: 		end sub
L_end_interrupt_low:
L__interrupt_low338:
	MOVF        ___Low_saveBSR+0, 0 
	MOVWF       BSR+0 
	MOVF        ___Low_saveSTATUS+0, 0 
	MOVWF       STATUS+0 
	SWAPF       ___Low_saveWREG+0, 1 
	SWAPF       ___Low_saveWREG+0, 0 
	RETFIE      0
; end of _interrupt_low

_led7seg_decode:

;ballisticchronograph.mbas,232 :: 		sub function led7seg_decode( dim ascii_char as byte ) as byte
;ballisticchronograph.mbas,234 :: 		case " "  result = Digit_NON
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode45
	CLRF        R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode45:
;ballisticchronograph.mbas,235 :: 		case "0"  result = Digit_0
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       48
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode48
	MOVLW       252
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode48:
;ballisticchronograph.mbas,236 :: 		case "1"  result = Digit_1
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       49
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode51
	MOVLW       96
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode51:
;ballisticchronograph.mbas,237 :: 		case "2"  result = Digit_2
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       50
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode54
	MOVLW       218
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode54:
;ballisticchronograph.mbas,238 :: 		case "3"  result = Digit_3
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       51
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode57
	MOVLW       242
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode57:
;ballisticchronograph.mbas,239 :: 		case "4"  result = Digit_4
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       52
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode60
	MOVLW       102
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode60:
;ballisticchronograph.mbas,240 :: 		case "5"  result = Digit_5
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       53
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode63
	MOVLW       182
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode63:
;ballisticchronograph.mbas,241 :: 		case "6"  result = Digit_6
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       54
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode66
	MOVLW       190
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode66:
;ballisticchronograph.mbas,242 :: 		case "7"  result = Digit_7
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       55
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode69
	MOVLW       224
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode69:
;ballisticchronograph.mbas,243 :: 		case "8"  result = Digit_8
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       56
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode72
	MOVLW       254
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode72:
;ballisticchronograph.mbas,244 :: 		case "9"  result = Digit_9
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       57
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode75
	MOVLW       246
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode75:
;ballisticchronograph.mbas,245 :: 		case "A"  result = Digit_A
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       65
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode78
	MOVLW       238
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode78:
;ballisticchronograph.mbas,246 :: 		case "d"  result = Digit_d
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode81
	MOVLW       122
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode81:
;ballisticchronograph.mbas,247 :: 		case "E"  result = Digit_E
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       69
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode84
	MOVLW       158
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode84:
;ballisticchronograph.mbas,248 :: 		case "F"  result = Digit_F
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       70
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode87
	MOVLW       142
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode87:
;ballisticchronograph.mbas,249 :: 		case "U"  result = Digit_U
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       85
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode90
	MOVLW       124
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode90:
;ballisticchronograph.mbas,250 :: 		case "P"  result = Digit_P
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       80
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode93
	MOVLW       206
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode93:
;ballisticchronograph.mbas,251 :: 		case "r"  result = Digit_r
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       114
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode96
	MOVLW       10
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode96:
;ballisticchronograph.mbas,252 :: 		case "S"  result = Digit_S
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       83
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode99
	MOVLW       182
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode99:
;ballisticchronograph.mbas,253 :: 		case "t"  result = Digit_t
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       116
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode102
	MOVLW       30
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode102:
;ballisticchronograph.mbas,254 :: 		case "_"  result = Digit_US
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       95
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode105
	MOVLW       16
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode105:
;ballisticchronograph.mbas,255 :: 		case "-"  result = Digit_MINUS
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       45
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode108
	MOVLW       2
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode108:
;ballisticchronograph.mbas,256 :: 		case "."  result = Digit_DP
	MOVF        FARG_led7seg_decode_ascii_char+0, 0 
	XORLW       46
	BTFSS       STATUS+0, 2 
	GOTO        L__led7seg_decode111
	MOVLW       1
	MOVWF       R1 
	GOTO        L__led7seg_decode42
L__led7seg_decode111:
;ballisticchronograph.mbas,257 :: 		case else result = Digit_NON
	CLRF        R1 
L__led7seg_decode42:
;ballisticchronograph.mbas,259 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_led7seg_decode:
	RETURN      0
; end of _led7seg_decode

_sw_test:

;ballisticchronograph.mbas,264 :: 		sub function sw_test( dim sw_no as byte ) as byte
;ballisticchronograph.mbas,265 :: 		if sw_enable = FALSE then
	MOVF        _sw_enable+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test114
;ballisticchronograph.mbas,266 :: 		result = SW_OFF
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test115
;ballisticchronograph.mbas,267 :: 		else
L__sw_test114:
;ballisticchronograph.mbas,269 :: 		case 1 result = SW1_PORT
	MOVF        FARG_sw_test_sw_no+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test119
	MOVLW       0
	BTFSC       PORTA+0, 3 
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test116
L__sw_test119:
;ballisticchronograph.mbas,270 :: 		case 2 result = SW2_PORT
	MOVF        FARG_sw_test_sw_no+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test122
	MOVLW       0
	BTFSC       PORTB+0, 4 
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test116
L__sw_test122:
;ballisticchronograph.mbas,271 :: 		case 3 result = SW3_PORT
	MOVF        FARG_sw_test_sw_no+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test125
	MOVLW       0
	BTFSC       PORTA+0, 1 
	MOVLW       1
	MOVWF       R1 
	GOTO        L__sw_test116
L__sw_test125:
L__sw_test116:
;ballisticchronograph.mbas,273 :: 		end if
L__sw_test115:
;ballisticchronograph.mbas,275 :: 		if result = SW_ON then
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__sw_test127
;ballisticchronograph.mbas,276 :: 		sw_enable = FALSE
	CLRF        _sw_enable+0 
L__sw_test127:
;ballisticchronograph.mbas,278 :: 		end sub
	MOVF        R1, 0 
	MOVWF       R0 
L_end_sw_test:
	RETURN      0
; end of _sw_test

_shift_out_char:

;ballisticchronograph.mbas,285 :: 		dim bit_pattern as byte
;ballisticchronograph.mbas,287 :: 		bit_pattern = led7seg_decode( chrarg )
	MOVF        FARG_shift_out_char_chrarg+0, 0 
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	MOVWF       shift_out_char_bit_pattern+0 
;ballisticchronograph.mbas,288 :: 		if dp then
	MOVF        FARG_shift_out_char_dp+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__shift_out_char131
;ballisticchronograph.mbas,289 :: 		bit_pattern = bit_pattern or led7seg_decode( "." )
	MOVLW       46
	MOVWF       FARG_led7seg_decode_ascii_char+0 
	CALL        _led7seg_decode+0, 0
	MOVF        R0, 0 
	IORWF       shift_out_char_bit_pattern+0, 1 
L__shift_out_char131:
;ballisticchronograph.mbas,292 :: 		counter = 8
	MOVLW       8
	MOVWF       shift_out_char_counter+0 
;ballisticchronograph.mbas,293 :: 		while counter > 0
L__shift_out_char134:
	MOVF        shift_out_char_counter+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__shift_out_char135
;ballisticchronograph.mbas,294 :: 		if (bit_pattern and 0x01) = 0x01 then
	MOVLW       1
	ANDWF       shift_out_char_bit_pattern+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__shift_out_char139
;ballisticchronograph.mbas,295 :: 		SHIFT_REGISTER_SI = 1
	BSF         LATC+0, 3 
	GOTO        L__shift_out_char140
;ballisticchronograph.mbas,296 :: 		else
L__shift_out_char139:
;ballisticchronograph.mbas,297 :: 		SHIFT_REGISTER_SI = 0
	BCF         LATC+0, 3 
;ballisticchronograph.mbas,298 :: 		end if
L__shift_out_char140:
;ballisticchronograph.mbas,299 :: 		SHIFT_REGISTER_SCK = 1
	BSF         LATC+0, 4 
;ballisticchronograph.mbas,300 :: 		nop
	NOP
;ballisticchronograph.mbas,301 :: 		SHIFT_REGISTER_SCK = 0
	BCF         LATC+0, 4 
;ballisticchronograph.mbas,302 :: 		bit_pattern = bit_pattern >> 1
	RRCF        shift_out_char_bit_pattern+0, 1 
	BCF         shift_out_char_bit_pattern+0, 7 
;ballisticchronograph.mbas,303 :: 		counter = counter - 1
	DECF        shift_out_char_counter+0, 1 
;ballisticchronograph.mbas,304 :: 		wend
	GOTO        L__shift_out_char134
L__shift_out_char135:
;ballisticchronograph.mbas,305 :: 		end sub
L_end_shift_out_char:
	RETURN      0
; end of _shift_out_char

_shift_out_string:

;ballisticchronograph.mbas,311 :: 		dim dp4 as boolean
;ballisticchronograph.mbas,313 :: 		dp1 = false
	CLRF        shift_out_string_dp1+0 
;ballisticchronograph.mbas,314 :: 		dp2 = false
	CLRF        shift_out_string_dp2+0 
;ballisticchronograph.mbas,315 :: 		dp3 = false
	CLRF        shift_out_string_dp3+0 
;ballisticchronograph.mbas,316 :: 		dp4 = false
	CLRF        shift_out_string_dp4+0 
;ballisticchronograph.mbas,319 :: 		case 1 dp1 = true
	MOVF        FARG_shift_out_string_dp_pos+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__shift_out_string145
	MOVLW       255
	MOVWF       shift_out_string_dp1+0 
	GOTO        L__shift_out_string142
L__shift_out_string145:
;ballisticchronograph.mbas,320 :: 		case 2 dp2 = true
	MOVF        FARG_shift_out_string_dp_pos+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__shift_out_string148
	MOVLW       255
	MOVWF       shift_out_string_dp2+0 
	GOTO        L__shift_out_string142
L__shift_out_string148:
;ballisticchronograph.mbas,321 :: 		case 3 dp3 = true
	MOVF        FARG_shift_out_string_dp_pos+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__shift_out_string151
	MOVLW       255
	MOVWF       shift_out_string_dp3+0 
	GOTO        L__shift_out_string142
L__shift_out_string151:
;ballisticchronograph.mbas,322 :: 		case 4 dp4 = true
	MOVF        FARG_shift_out_string_dp_pos+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__shift_out_string154
	MOVLW       255
	MOVWF       shift_out_string_dp4+0 
	GOTO        L__shift_out_string142
L__shift_out_string154:
L__shift_out_string142:
;ballisticchronograph.mbas,325 :: 		if shotgun_mode then
	MOVF        _shotgun_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__shift_out_string156
;ballisticchronograph.mbas,326 :: 		shift_out_char( char4, True )
	MOVF        FARG_shift_out_string_char4+0, 0 
	MOVWF       FARG_shift_out_char_chrarg+0 
	MOVLW       255
	MOVWF       FARG_shift_out_char_dp+0 
	CALL        _shift_out_char+0, 0
	GOTO        L__shift_out_string157
;ballisticchronograph.mbas,327 :: 		else
L__shift_out_string156:
;ballisticchronograph.mbas,328 :: 		shift_out_char( char4, dp1 )
	MOVF        FARG_shift_out_string_char4+0, 0 
	MOVWF       FARG_shift_out_char_chrarg+0 
	MOVF        shift_out_string_dp1+0, 0 
	MOVWF       FARG_shift_out_char_dp+0 
	CALL        _shift_out_char+0, 0
;ballisticchronograph.mbas,329 :: 		end if
L__shift_out_string157:
;ballisticchronograph.mbas,330 :: 		shift_out_char( char3, dp2 )
	MOVF        FARG_shift_out_string_char3+0, 0 
	MOVWF       FARG_shift_out_char_chrarg+0 
	MOVF        shift_out_string_dp2+0, 0 
	MOVWF       FARG_shift_out_char_dp+0 
	CALL        _shift_out_char+0, 0
;ballisticchronograph.mbas,331 :: 		shift_out_char( char2, dp3 )
	MOVF        FARG_shift_out_string_char2+0, 0 
	MOVWF       FARG_shift_out_char_chrarg+0 
	MOVF        shift_out_string_dp3+0, 0 
	MOVWF       FARG_shift_out_char_dp+0 
	CALL        _shift_out_char+0, 0
;ballisticchronograph.mbas,332 :: 		shift_out_char( char1, dp4 )
	MOVF        FARG_shift_out_string_char1+0, 0 
	MOVWF       FARG_shift_out_char_chrarg+0 
	MOVF        shift_out_string_dp4+0, 0 
	MOVWF       FARG_shift_out_char_dp+0 
	CALL        _shift_out_char+0, 0
;ballisticchronograph.mbas,334 :: 		SHIFT_REGISTER_RCK = 1
	BSF         LATC+0, 6 
;ballisticchronograph.mbas,335 :: 		nop
	NOP
;ballisticchronograph.mbas,336 :: 		SHIFT_REGISTER_RCK = 0
	BCF         LATC+0, 6 
;ballisticchronograph.mbas,337 :: 		end sub
L_end_shift_out_string:
	RETURN      0
; end of _shift_out_string

_clear_display:

;ballisticchronograph.mbas,339 :: 		sub procedure clear_display()
;ballisticchronograph.mbas,340 :: 		SHIFT_REGISTER_SCLR = 0
	BCF         LATC+0, 5 
;ballisticchronograph.mbas,341 :: 		nop
	NOP
;ballisticchronograph.mbas,342 :: 		SHIFT_REGISTER_SCLR = 1
	BSF         LATC+0, 5 
;ballisticchronograph.mbas,343 :: 		SHIFT_REGISTER_RCK = 1
	BSF         LATC+0, 6 
;ballisticchronograph.mbas,344 :: 		nop
	NOP
;ballisticchronograph.mbas,345 :: 		SHIFT_REGISTER_RCK = 0
	BCF         LATC+0, 6 
;ballisticchronograph.mbas,346 :: 		SHIFT_REGISTER_G = 0  ' output ENABLE
	BCF         LATC+0, 7 
;ballisticchronograph.mbas,347 :: 		end sub
L_end_clear_display:
	RETURN      0
; end of _clear_display

_display_velocity_unit:

;ballisticchronograph.mbas,349 :: 		sub procedure display_velocity_unit(dim velocity_unit as byte)
;ballisticchronograph.mbas,350 :: 		LED1_PORT = LED_OFF
	BCF         LATB+0, 6 
;ballisticchronograph.mbas,351 :: 		LED2_PORT = LED_OFF
	BCF         LATC+0, 0 
;ballisticchronograph.mbas,352 :: 		LED3_PORT = LED_OFF
	BCF         LATC+0, 1 
;ballisticchronograph.mbas,354 :: 		case VELOCITY_MPS LED1_PORT = LED_ON
	MOVF        FARG_display_velocity_unit_velocity_unit+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity_unit163
	BSF         LATB+0, 6 
	GOTO        L__display_velocity_unit160
L__display_velocity_unit163:
;ballisticchronograph.mbas,355 :: 		case VELOCITY_KPH LED2_PORT = LED_ON
	MOVF        FARG_display_velocity_unit_velocity_unit+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity_unit166
	BSF         LATC+0, 0 
	GOTO        L__display_velocity_unit160
L__display_velocity_unit166:
;ballisticchronograph.mbas,356 :: 		case VELOCITY_FPS LED3_PORT = LED_ON
	MOVF        FARG_display_velocity_unit_velocity_unit+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity_unit169
	BSF         LATC+0, 1 
	GOTO        L__display_velocity_unit160
L__display_velocity_unit169:
L__display_velocity_unit160:
;ballisticchronograph.mbas,358 :: 		end sub
L_end_display_velocity_unit:
	RETURN      0
; end of _display_velocity_unit

_display_message:

;ballisticchronograph.mbas,363 :: 		sub procedure display_message( dim error_code as byte )
;ballisticchronograph.mbas,364 :: 		current_status = error_code
	MOVF        FARG_display_message_error_code+0, 0 
	MOVWF       _current_status+0 
;ballisticchronograph.mbas,366 :: 		case ERROR_SCREEN_1ST ' ERROR
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message174
;ballisticchronograph.mbas,367 :: 		shift_out_string( "E", "_", "_", "1", 0 )
	MOVLW       69
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       95
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       95
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       49
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message174:
;ballisticchronograph.mbas,368 :: 		case ERROR_FAST       ' FAST
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message177
;ballisticchronograph.mbas,369 :: 		shift_out_string( "F", "A", "S", "t", 0 )
	MOVLW       70
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       65
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       83
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       116
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message177:
;ballisticchronograph.mbas,370 :: 		case MSG_SAVE         ' SAVE
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message180
;ballisticchronograph.mbas,371 :: 		shift_out_string( "S", "A", "U", "E", 0 )
	MOVLW       83
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       65
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       85
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       69
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message180:
;ballisticchronograph.mbas,372 :: 		case MSG_READY        ' -  -
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message183
;ballisticchronograph.mbas,373 :: 		shift_out_string( "_", " ", " ", "_", 0 )
	MOVLW       95
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       32
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       32
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       95
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message183:
;ballisticchronograph.mbas,374 :: 		case MSG_TEST         ' TEST
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message186
;ballisticchronograph.mbas,375 :: 		shift_out_string( "t", "E", "S", "t", 0 )
	MOVLW       116
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       69
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       83
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       116
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message186:
;ballisticchronograph.mbas,376 :: 		case ERROR_PULSE      ' E_dP
	MOVF        FARG_display_message_error_code+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L__display_message189
;ballisticchronograph.mbas,377 :: 		shift_out_string( "E", "_", "d", "P", 0 )
	MOVLW       69
	MOVWF       FARG_shift_out_string_char1+0 
	MOVLW       95
	MOVWF       FARG_shift_out_string_char2+0 
	MOVLW       100
	MOVWF       FARG_shift_out_string_char3+0 
	MOVLW       80
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
	GOTO        L__display_message171
L__display_message189:
L__display_message171:
;ballisticchronograph.mbas,379 :: 		end sub
L_end_display_message:
	RETURN      0
; end of _display_message

_display_number:

;ballisticchronograph.mbas,385 :: 		dim text as string[5]
;ballisticchronograph.mbas,387 :: 		WordToStr( num, text )
	MOVF        FARG_display_number_num+0, 0 
	MOVWF       FARG_WordToStr_input+0 
	MOVF        FARG_display_number_num+1, 0 
	MOVWF       FARG_WordToStr_input+1 
	MOVLW       display_number_text+0
	MOVWF       FARG_WordToStr_output+0 
	MOVLW       hi_addr(display_number_text+0)
	MOVWF       FARG_WordToStr_output+1 
	CALL        _WordToStr+0, 0
;ballisticchronograph.mbas,388 :: 		shift_out_string( text[1], text[2], text[3], text[4], 0 )
	MOVF        display_number_text+1, 0 
	MOVWF       FARG_shift_out_string_char1+0 
	MOVF        display_number_text+2, 0 
	MOVWF       FARG_shift_out_string_char2+0 
	MOVF        display_number_text+3, 0 
	MOVWF       FARG_shift_out_string_char3+0 
	MOVF        display_number_text+4, 0 
	MOVWF       FARG_shift_out_string_char4+0 
	CLRF        FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
;ballisticchronograph.mbas,389 :: 		end sub
L_end_display_number:
	RETURN      0
; end of _display_number

_display_number_dp:

;ballisticchronograph.mbas,395 :: 		dim text as string[5]
;ballisticchronograph.mbas,397 :: 		WordToStr( num, text )
	MOVF        FARG_display_number_dp_num+0, 0 
	MOVWF       FARG_WordToStr_input+0 
	MOVF        FARG_display_number_dp_num+1, 0 
	MOVWF       FARG_WordToStr_input+1 
	MOVLW       display_number_dp_text+0
	MOVWF       FARG_WordToStr_output+0 
	MOVLW       hi_addr(display_number_dp_text+0)
	MOVWF       FARG_WordToStr_output+1 
	CALL        _WordToStr+0, 0
;ballisticchronograph.mbas,398 :: 		shift_out_string( text[1], text[2], text[3], text[4], dp_position )
	MOVF        display_number_dp_text+1, 0 
	MOVWF       FARG_shift_out_string_char1+0 
	MOVF        display_number_dp_text+2, 0 
	MOVWF       FARG_shift_out_string_char2+0 
	MOVF        display_number_dp_text+3, 0 
	MOVWF       FARG_shift_out_string_char3+0 
	MOVF        display_number_dp_text+4, 0 
	MOVWF       FARG_shift_out_string_char4+0 
	MOVF        FARG_display_number_dp_dp_position+0, 0 
	MOVWF       FARG_shift_out_string_dp_pos+0 
	CALL        _shift_out_string+0, 0
;ballisticchronograph.mbas,399 :: 		end sub
L_end_display_number_dp:
	RETURN      0
; end of _display_number_dp

_display_velocity:

;ballisticchronograph.mbas,404 :: 		sub procedure display_velocity( dim velocity as double, dim unit as byte  )
;ballisticchronograph.mbas,406 :: 		case VELOCITY_MPS  display_number_dp( velocity * 10, 2 )
	MOVF        FARG_display_velocity_unit+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity196
	MOVF        FARG_display_velocity_velocity+0, 0 
	MOVWF       R0 
	MOVF        FARG_display_velocity_velocity+1, 0 
	MOVWF       R1 
	MOVF        FARG_display_velocity_velocity+2, 0 
	MOVWF       R2 
	MOVF        FARG_display_velocity_velocity+3, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       32
	MOVWF       R6 
	MOVLW       130
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_display_number_dp_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_display_number_dp_num+1 
	MOVLW       2
	MOVWF       FARG_display_number_dp_dp_position+0 
	CALL        _display_number_dp+0, 0
	GOTO        L__display_velocity193
L__display_velocity196:
;ballisticchronograph.mbas,407 :: 		case VELOCITY_KPH  display_number_dp( velocity * 36 / 10, 0 )
	MOVF        FARG_display_velocity_unit+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity199
	MOVF        FARG_display_velocity_velocity+0, 0 
	MOVWF       R0 
	MOVF        FARG_display_velocity_velocity+1, 0 
	MOVWF       R1 
	MOVF        FARG_display_velocity_velocity+2, 0 
	MOVWF       R2 
	MOVF        FARG_display_velocity_velocity+3, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       16
	MOVWF       R6 
	MOVLW       132
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       32
	MOVWF       R6 
	MOVLW       130
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_display_number_dp_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_display_number_dp_num+1 
	CLRF        FARG_display_number_dp_dp_position+0 
	CALL        _display_number_dp+0, 0
	GOTO        L__display_velocity193
L__display_velocity199:
;ballisticchronograph.mbas,408 :: 		case VELOCITY_FPS  display_number_dp( velocity * 10000 / 3048, 0 )
	MOVF        FARG_display_velocity_unit+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__display_velocity202
	MOVF        FARG_display_velocity_velocity+0, 0 
	MOVWF       R0 
	MOVF        FARG_display_velocity_velocity+1, 0 
	MOVWF       R1 
	MOVF        FARG_display_velocity_velocity+2, 0 
	MOVWF       R2 
	MOVF        FARG_display_velocity_velocity+3, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       64
	MOVWF       R5 
	MOVLW       28
	MOVWF       R6 
	MOVLW       140
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       128
	MOVWF       R5 
	MOVLW       62
	MOVWF       R6 
	MOVLW       138
	MOVWF       R7 
	CALL        _Div_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_display_number_dp_num+0 
	MOVF        R1, 0 
	MOVWF       FARG_display_number_dp_num+1 
	CLRF        FARG_display_number_dp_dp_position+0 
	CALL        _display_number_dp+0, 0
	GOTO        L__display_velocity193
L__display_velocity202:
L__display_velocity193:
;ballisticchronograph.mbas,410 :: 		end sub
L_end_display_velocity:
	RETURN      0
; end of _display_velocity

_reset_screen:

;ballisticchronograph.mbas,415 :: 		sub procedure reset_screen()
;ballisticchronograph.mbas,416 :: 		screen1st_detect = False
	CLRF        _screen1st_detect+0 
;ballisticchronograph.mbas,417 :: 		screen2nd_detect = False
	CLRF        _screen2nd_detect+0 
;ballisticchronograph.mbas,418 :: 		screen_timeout   = False
	CLRF        _screen_timeout+0 
;ballisticchronograph.mbas,419 :: 		pulse_error      = False
	CLRF        _pulse_error+0 
;ballisticchronograph.mbas,420 :: 		delay_ms(1)
	MOVLW       21
	MOVWF       R12, 0
	MOVLW       198
	MOVWF       R13, 0
L__reset_screen204:
	DECFSZ      R13, 1, 1
	BRA         L__reset_screen204
	DECFSZ      R12, 1, 1
	BRA         L__reset_screen204
	NOP
;ballisticchronograph.mbas,421 :: 		INT0IF_bit = FLAG_CLEAR
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
;ballisticchronograph.mbas,422 :: 		INT0IE_bit = INTERRUPT_ENABLE
	BSF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,423 :: 		INT2IF_bit = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,424 :: 		INT2IE_bit = INTERRUPT_DISABLE
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,425 :: 		end sub
L_end_reset_screen:
	RETURN      0
; end of _reset_screen

_disable_screen:

;ballisticchronograph.mbas,430 :: 		sub procedure disable_screen()
;ballisticchronograph.mbas,431 :: 		INT0IE_bit = INTERRUPT_DISABLE
	BCF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,432 :: 		INT2IE_bit = INTERRUPT_DISABLE
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,433 :: 		end sub
L_end_disable_screen:
	RETURN      0
; end of _disable_screen

_calc_velocity_mps:

;ballisticchronograph.mbas,440 :: 		dim divisor  as double
;ballisticchronograph.mbas,442 :: 		dividend = (CONST_SEC / 1000 ) * screen_distance
	MOVF        FARG_calc_velocity_mps_screen_distance+0, 0 
	MOVWF       R0 
	MOVF        FARG_calc_velocity_mps_screen_distance+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       122
	MOVWF       R6 
	MOVLW       140
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__calc_velocity_mps+4 
	MOVF        R1, 0 
	MOVWF       FLOC__calc_velocity_mps+5 
	MOVF        R2, 0 
	MOVWF       FLOC__calc_velocity_mps+6 
	MOVF        R3, 0 
	MOVWF       FLOC__calc_velocity_mps+7 
	MOVF        FARG_calc_velocity_mps_overflow+0, 0 
	MOVWF       R0 
	CALL        _Byte2Double+0, 0
;ballisticchronograph.mbas,443 :: 		divisor  = (tmr_value + (overflow * 0x10000))
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       143
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__calc_velocity_mps+0 
	MOVF        R1, 0 
	MOVWF       FLOC__calc_velocity_mps+1 
	MOVF        R2, 0 
	MOVWF       FLOC__calc_velocity_mps+2 
	MOVF        R3, 0 
	MOVWF       FLOC__calc_velocity_mps+3 
	MOVF        FARG_calc_velocity_mps_tmr_value+0, 0 
	MOVWF       R0 
	MOVF        FARG_calc_velocity_mps_tmr_value+1, 0 
	MOVWF       R1 
	CALL        _Word2Double+0, 0
	MOVF        FLOC__calc_velocity_mps+0, 0 
	MOVWF       R4 
	MOVF        FLOC__calc_velocity_mps+1, 0 
	MOVWF       R5 
	MOVF        FLOC__calc_velocity_mps+2, 0 
	MOVWF       R6 
	MOVF        FLOC__calc_velocity_mps+3, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
;ballisticchronograph.mbas,444 :: 		result = dividend / divisor
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVF        FLOC__calc_velocity_mps+4, 0 
	MOVWF       R0 
	MOVF        FLOC__calc_velocity_mps+5, 0 
	MOVWF       R1 
	MOVF        FLOC__calc_velocity_mps+6, 0 
	MOVWF       R2 
	MOVF        FLOC__calc_velocity_mps+7, 0 
	MOVWF       R3 
	CALL        _Div_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       calc_velocity_mps_local_result+0 
	MOVF        R1, 0 
	MOVWF       calc_velocity_mps_local_result+1 
	MOVF        R2, 0 
	MOVWF       calc_velocity_mps_local_result+2 
	MOVF        R3, 0 
	MOVWF       calc_velocity_mps_local_result+3 
;ballisticchronograph.mbas,445 :: 		end sub
	MOVF        calc_velocity_mps_local_result+0, 0 
	MOVWF       R0 
	MOVF        calc_velocity_mps_local_result+1, 0 
	MOVWF       R1 
	MOVF        calc_velocity_mps_local_result+2, 0 
	MOVWF       R2 
	MOVF        calc_velocity_mps_local_result+3, 0 
	MOVWF       R3 
L_end_calc_velocity_mps:
	RETURN      0
; end of _calc_velocity_mps

_input_number:

;ballisticchronograph.mbas,453 :: 		dim i                as byte
;ballisticchronograph.mbas,455 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,457 :: 		for i = 0 to 3
	CLRF        input_number_i+0 
L__input_number209:
;ballisticchronograph.mbas,458 :: 		value[i] = initial mod 10
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_i+0, 0 
	ADDWF       R0, 0 
	MOVWF       FLOC__input_number+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FLOC__input_number+1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_input_number_initial+0, 0 
	MOVWF       R0 
	MOVF        FARG_input_number_initial+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVFF       FLOC__input_number+0, FSR1
	MOVFF       FLOC__input_number+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ballisticchronograph.mbas,459 :: 		initial  = initial  /  10
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        FARG_input_number_initial+0, 0 
	MOVWF       R0 
	MOVF        FARG_input_number_initial+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_input_number_initial+0 
	MOVF        R1, 0 
	MOVWF       FARG_input_number_initial+1 
;ballisticchronograph.mbas,460 :: 		next i
	MOVF        input_number_i+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L__input_number212
	INCF        input_number_i+0, 1 
	GOTO        L__input_number209
L__input_number212:
;ballisticchronograph.mbas,462 :: 		digit_index = 0
	CLRF        input_number_digit_index+0 
;ballisticchronograph.mbas,463 :: 		while sw_test(3) = SW_OFF
L__input_number214:
	MOVLW       3
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number215
;ballisticchronograph.mbas,464 :: 		display_number_dp(  value[3] * 1000 +  value[2] * 100 +  value[1] * 10 +  value[0], digit_index + 1 )
	MOVF        input_number_value+3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__input_number+0 
	MOVF        R1, 0 
	MOVWF       FLOC__input_number+1 
	MOVF        input_number_value+2, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	ADDWF       FLOC__input_number+0, 0 
	MOVWF       FARG_display_number_dp_num+0 
	MOVF        R1, 0 
	ADDWFC      FLOC__input_number+1, 0 
	MOVWF       FARG_display_number_dp_num+1 
	MOVF        input_number_value+1, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	ADDWF       FARG_display_number_dp_num+0, 1 
	MOVF        R1, 0 
	ADDWFC      FARG_display_number_dp_num+1, 1 
	MOVF        input_number_value+0, 0 
	ADDWF       FARG_display_number_dp_num+0, 1 
	MOVLW       0
	ADDWFC      FARG_display_number_dp_num+1, 1 
	MOVF        input_number_digit_index+0, 0 
	ADDLW       1
	MOVWF       FARG_display_number_dp_dp_position+0 
	CALL        _display_number_dp+0, 0
;ballisticchronograph.mbas,466 :: 		if sw_test(2) = SW_ON then
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number219
;ballisticchronograph.mbas,467 :: 		digit_index = digit_index + 1
	INCF        input_number_digit_index+0, 1 
;ballisticchronograph.mbas,468 :: 		if digit_index = digit_number then
	MOVF        input_number_digit_index+0, 0 
	XORWF       FARG_input_number_digit_number+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number222
;ballisticchronograph.mbas,469 :: 		digit_index = 0
	CLRF        input_number_digit_index+0 
L__input_number222:
;ballisticchronograph.mbas,470 :: 		end if
L__input_number219:
;ballisticchronograph.mbas,473 :: 		if sw_test(1) = SW_ON then
	MOVLW       1
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number225
;ballisticchronograph.mbas,474 :: 		if value[digit_index] = 9 then
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__input_number228
;ballisticchronograph.mbas,475 :: 		value[digit_index] = 0
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	GOTO        L__input_number229
;ballisticchronograph.mbas,476 :: 		else
L__input_number228:
;ballisticchronograph.mbas,477 :: 		value[digit_index] = value[digit_index] + 1
	MOVLW       input_number_value+0
	MOVWF       R0 
	MOVLW       hi_addr(input_number_value+0)
	MOVWF       R1 
	MOVF        input_number_digit_index+0, 0 
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0
	MOVFF       R3, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDLW       1
	MOVWF       R0 
	MOVFF       R2, FSR1
	MOVFF       R3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ballisticchronograph.mbas,478 :: 		end if
L__input_number229:
L__input_number225:
;ballisticchronograph.mbas,480 :: 		wend
	GOTO        L__input_number214
L__input_number215:
;ballisticchronograph.mbas,482 :: 		result = value[3] * 1000 +  value[2] * 100 +  value[1] * 10 +  value[0]
	MOVF        input_number_value+3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       232
	MOVWF       R4 
	MOVLW       3
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__input_number+0 
	MOVF        R1, 0 
	MOVWF       FLOC__input_number+1 
	MOVF        input_number_value+2, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        R0, 0 
	ADDWF       FLOC__input_number+0, 1 
	MOVF        R1, 0 
	ADDWFC      FLOC__input_number+1, 1 
	MOVF        input_number_value+1, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVF        FLOC__input_number+0, 0 
	ADDWF       R0, 1 
	MOVF        FLOC__input_number+1, 0 
	ADDWFC      R1, 1 
	MOVF        input_number_value+0, 0 
	ADDWF       R0, 0 
	MOVWF       input_number_local_result+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       input_number_local_result+1 
;ballisticchronograph.mbas,483 :: 		end sub
	MOVF        input_number_local_result+0, 0 
	MOVWF       R0 
	MOVF        input_number_local_result+1, 0 
	MOVWF       R1 
L_end_input_number:
	RETURN      0
; end of _input_number

_main:

;ballisticchronograph.mbas,490 :: 		dim tx_string  as string[10]
;ballisticchronograph.mbas,493 :: 		RABPU_bit = 1 ' PORTA and PORTB pull-ups are disabled
	BSF         RABPU_bit+0, BitPos(RABPU_bit+0) 
;ballisticchronograph.mbas,494 :: 		WPUA = 0   ' 0:pull-up disable
	CLRF        WPUA+0 
;ballisticchronograph.mbas,495 :: 		WPUB = 0   ' 0:pull-up disable
	CLRF        WPUB+0 
;ballisticchronograph.mbas,498 :: 		SCREEN_1ST_TRIS = PORT_INPUT
	BSF         TRISA+0, 0 
;ballisticchronograph.mbas,499 :: 		SCREEN_2ND_TRIS = PORT_INPUT
	BSF         TRISA+0, 2 
;ballisticchronograph.mbas,500 :: 		ANS2_bit    = 0 ' PORT digital input   2nd screen
	BCF         ANS2_bit+0, BitPos(ANS2_bit+0) 
;ballisticchronograph.mbas,501 :: 		ANS0_bit    = 0 ' PORT digital input   1st screen
	BCF         ANS0_bit+0, BitPos(ANS0_bit+0) 
;ballisticchronograph.mbas,502 :: 		INTEDG2_bit = 1 ' 1:Interrupt on rising edge
	BSF         INTEDG2_bit+0, BitPos(INTEDG2_bit+0) 
;ballisticchronograph.mbas,503 :: 		INT2IP_bit  = HIGH_PRIORITY
	BSF         INT2IP_bit+0, BitPos(INT2IP_bit+0) 
;ballisticchronograph.mbas,504 :: 		INT2IE_bit  = INTERRUPT_DISABLE ' INT2 external interrupt
	BCF         INT2IE_bit+0, BitPos(INT2IE_bit+0) 
;ballisticchronograph.mbas,505 :: 		INT2IF_bit  = FLAG_CLEAR
	BCF         INT2IF_bit+0, BitPos(INT2IF_bit+0) 
;ballisticchronograph.mbas,506 :: 		INTEDG0_bit = 1 ' 1:Interrupt on rising edge
	BSF         INTEDG0_bit+0, BitPos(INTEDG0_bit+0) 
;ballisticchronograph.mbas,507 :: 		INT0IE_bit  = INTERRUPT_DISABLE ' INT0 external interrupt
	BCF         INT0IE_bit+0, BitPos(INT0IE_bit+0) 
;ballisticchronograph.mbas,508 :: 		INT0IF_bit  = FLAG_CLEAR ' Clear flag
	BCF         INT0IF_bit+0, BitPos(INT0IF_bit+0) 
;ballisticchronograph.mbas,511 :: 		SW1_TRIS = PORT_INPUT
	BSF         TRISA+0, 3 
;ballisticchronograph.mbas,512 :: 		SW2_TRIS = PORT_INPUT
	BSF         TRISB+0, 4 
;ballisticchronograph.mbas,513 :: 		SW3_TRIS = PORT_INPUT
	BSF         TRISA+0, 1 
;ballisticchronograph.mbas,514 :: 		ANS1_bit    = 0 ' PORT digital input
	BCF         ANS1_bit+0, BitPos(ANS1_bit+0) 
;ballisticchronograph.mbas,515 :: 		ANS10_bit   = 0 ' PORT digital input
	BCF         ANS10_bit+0, BitPos(ANS10_bit+0) 
;ballisticchronograph.mbas,518 :: 		SHIFT_REGISTER_SI_TRIS   = PORT_OUTPUT
	BCF         TRISC+0, 3 
;ballisticchronograph.mbas,519 :: 		SHIFT_REGISTER_SCK_TRIS  = PORT_OUTPUT
	BCF         TRISC+0, 4 
;ballisticchronograph.mbas,520 :: 		SHIFT_REGISTER_SCLR_TRIS = PORT_OUTPUT
	BCF         TRISC+0, 5 
;ballisticchronograph.mbas,521 :: 		SHIFT_REGISTER_RCK_TRIS  = PORT_OUTPUT
	BCF         TRISC+0, 6 
;ballisticchronograph.mbas,522 :: 		SHIFT_REGISTER_G_TRIS    = PORT_OUTPUT
	BCF         TRISC+0, 7 
;ballisticchronograph.mbas,524 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,526 :: 		LED1_TRIS = PORT_OUTPUT
	BCF         TRISB+0, 6 
;ballisticchronograph.mbas,527 :: 		LED2_TRIS = PORT_OUTPUT
	BCF         TRISC+0, 0 
;ballisticchronograph.mbas,528 :: 		LED3_TRIS = PORT_OUTPUT
	BCF         TRISC+0, 1 
;ballisticchronograph.mbas,529 :: 		LED4_TRIS = PORT_OUTPUT
	BCF         TRISC+0, 2 
;ballisticchronograph.mbas,531 :: 		sw_enable = true
	MOVLW       255
	MOVWF       _sw_enable+0 
;ballisticchronograph.mbas,534 :: 		T0PS2_bit   = 1  ' PreScaler 1:256
	BSF         T0PS2_bit+0, BitPos(T0PS2_bit+0) 
;ballisticchronograph.mbas,535 :: 		T0PS1_bit   = 1  ' PreScaler 1:256
	BSF         T0PS1_bit+0, BitPos(T0PS1_bit+0) 
;ballisticchronograph.mbas,536 :: 		T0PS0_bit   = 1  ' PreScaler 1:256
	BSF         T0PS0_bit+0, BitPos(T0PS0_bit+0) 
;ballisticchronograph.mbas,537 :: 		PSA_bit     = 0  ' PreScaler assign TMR0
	BCF         PSA_bit+0, BitPos(PSA_bit+0) 
;ballisticchronograph.mbas,538 :: 		T08BIT_bit  = 0  ' 1: 16bit mode
	BCF         T08BIT_bit+0, BitPos(T08BIT_bit+0) 
;ballisticchronograph.mbas,539 :: 		TMR0IE_bit  = INTERRUPT_DISABLE
	BCF         TMR0IE_bit+0, BitPos(TMR0IE_bit+0) 
;ballisticchronograph.mbas,540 :: 		T0CS_bit    = 0  ' 0:internal clock
	BCF         T0CS_bit+0, BitPos(T0CS_bit+0) 
;ballisticchronograph.mbas,541 :: 		TMR0ON_bit  = TIMER_ON  ' 1:Enables Timer0
	BSF         TMR0ON_bit+0, BitPos(TMR0ON_bit+0) 
;ballisticchronograph.mbas,544 :: 		RD16_bit    = 1  ' 1:16bit mode
	BSF         RD16_bit+0, BitPos(RD16_bit+0) 
;ballisticchronograph.mbas,545 :: 		TMR1IF_bit  = FLAG_CLEAR
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;ballisticchronograph.mbas,546 :: 		TMR1IE_bit  = INTERRUPT_ENABLE
	BSF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;ballisticchronograph.mbas,547 :: 		TMR1IP_bit  = LOW_PRIORITY
	BCF         TMR1IP_bit+0, BitPos(TMR1IP_bit+0) 
;ballisticchronograph.mbas,548 :: 		T1CKPS1_bit = 0  ' set prescaler 1:1
	BCF         T1CKPS1_bit+0, BitPos(T1CKPS1_bit+0) 
;ballisticchronograph.mbas,549 :: 		T1CKPS0_bit = 0  ' set prescaler 1:1
	BCF         T1CKPS0_bit+0, BitPos(T1CKPS0_bit+0) 
;ballisticchronograph.mbas,550 :: 		TMR1CS_bit  = 0  ' 0:Internal clock (FOSC/4)
	BCF         TMR1CS_bit+0, BitPos(TMR1CS_bit+0) 
;ballisticchronograph.mbas,551 :: 		TMR1ON_bit  = TIMER_ON
	BSF         TMR1ON_bit+0, BitPos(TMR1ON_bit+0) 
;ballisticchronograph.mbas,554 :: 		T2CKPS1_bit   = 1   ' PreScaler 1:16
	BSF         T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0) 
;ballisticchronograph.mbas,555 :: 		T2CKPS0_bit   = 0   ' PreScaler 1:16
	BCF         T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0) 
;ballisticchronograph.mbas,556 :: 		T2OUTPS3_bit  = 1   ' Postscale 1:10
	BSF         T2OUTPS3_bit+0, BitPos(T2OUTPS3_bit+0) 
;ballisticchronograph.mbas,557 :: 		T2OUTPS2_bit  = 0   ' Postscale 1:10
	BCF         T2OUTPS2_bit+0, BitPos(T2OUTPS2_bit+0) 
;ballisticchronograph.mbas,558 :: 		T2OUTPS1_bit  = 0   ' Postscale 1:10
	BCF         T2OUTPS1_bit+0, BitPos(T2OUTPS1_bit+0) 
;ballisticchronograph.mbas,559 :: 		T2OUTPS0_bit  = 1   ' Postscale 1:10
	BSF         T2OUTPS0_bit+0, BitPos(T2OUTPS0_bit+0) 
;ballisticchronograph.mbas,560 :: 		PR2           = 99  ' 1ms period
	MOVLW       99
	MOVWF       PR2+0 
;ballisticchronograph.mbas,561 :: 		TMR2IP_bit    = LOW_PRIORITY
	BCF         TMR2IP_bit+0, BitPos(TMR2IP_bit+0) 
;ballisticchronograph.mbas,562 :: 		TMR2ON_bit    = TIMER_ON
	BSF         TMR2ON_bit+0, BitPos(TMR2ON_bit+0) 
;ballisticchronograph.mbas,563 :: 		TMR2IE_bit    = INTERRUPT_ENABLE
	BSF         TMR2IE_bit+0, BitPos(TMR2IE_bit+0) 
;ballisticchronograph.mbas,564 :: 		TMR2IF_bit    = FLAG_CLEAR
	BCF         TMR2IF_bit+0, BitPos(TMR2IF_bit+0) 
;ballisticchronograph.mbas,566 :: 		UART1_Init(19200)
	BSF         BAUDCON+0, 3, 0
	MOVLW       3
	MOVWF       SPBRGH+0 
	MOVLW       64
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ballisticchronograph.mbas,568 :: 		LED1_PORT = LED_OFF
	BCF         LATB+0, 6 
;ballisticchronograph.mbas,569 :: 		LED2_PORT = LED_OFF
	BCF         LATC+0, 0 
;ballisticchronograph.mbas,570 :: 		LED3_PORT = LED_OFF
	BCF         LATC+0, 1 
;ballisticchronograph.mbas,571 :: 		LED4_PORT = LED_OFF
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,573 :: 		shotgun_mode = False
	CLRF        _shotgun_mode+0 
;ballisticchronograph.mbas,574 :: 		screen_distance_mm = eeprom_read( EEPADDR_DISTANCE ) + eeprom_read( EEPADDR_DISTANCE + 1 ) * 0x100
	CLRF        FARG_EEPROM_Read_address+0 
	CLRF        FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__main+0 
	MOVLW       1
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       R2 
	CLRF        R1 
	MOVF        FLOC__main+0, 0 
	ADDWF       R1, 0 
	MOVWF       _screen_distance_mm+0 
	MOVLW       0
	ADDWFC      R2, 0 
	MOVWF       _screen_distance_mm+1 
;ballisticchronograph.mbas,575 :: 		velocity_unit      = eeprom_read( EEPADDR_VELOCITY_UNIT )
	MOVLW       2
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _velocity_unit+0 
;ballisticchronograph.mbas,576 :: 		serial_out_mode    = eeprom_read( EEPADDR_SERIAL_OUT_MODE )
	MOVLW       3
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _serial_out_mode+0 
;ballisticchronograph.mbas,578 :: 		if serial_out_mode then
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main232
;ballisticchronograph.mbas,579 :: 		LED4_PORT = 1
	BSF         LATC+0, 2 
	GOTO        L__main233
;ballisticchronograph.mbas,580 :: 		else
L__main232:
;ballisticchronograph.mbas,581 :: 		LED4_PORT = 0
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,582 :: 		end if
L__main233:
;ballisticchronograph.mbas,585 :: 		if sw_test(2) = SW_ON then
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main235
;ballisticchronograph.mbas,586 :: 		display_message( MSG_TEST )
	MOVLW       5
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,587 :: 		while true
L__main238:
;ballisticchronograph.mbas,588 :: 		if SCREEN_1ST_PORT = 1 then
	BTFSS       PORTA+0, 0 
	GOTO        L__main243
;ballisticchronograph.mbas,589 :: 		LED1_PORT = LED_ON
	BSF         LATB+0, 6 
	GOTO        L__main244
;ballisticchronograph.mbas,590 :: 		else
L__main243:
;ballisticchronograph.mbas,591 :: 		LED1_PORT = LED_OFF
	BCF         LATB+0, 6 
;ballisticchronograph.mbas,592 :: 		end if
L__main244:
;ballisticchronograph.mbas,593 :: 		if SCREEN_2ND_PORT = 1 then
	BTFSS       PORTA+0, 2 
	GOTO        L__main246
;ballisticchronograph.mbas,594 :: 		LED4_PORT = LED_ON
	BSF         LATC+0, 2 
	GOTO        L__main247
;ballisticchronograph.mbas,595 :: 		else
L__main246:
;ballisticchronograph.mbas,596 :: 		LED4_PORT = LED_OFF
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,597 :: 		end if
L__main247:
;ballisticchronograph.mbas,598 :: 		wend
	GOTO        L__main238
L__main235:
;ballisticchronograph.mbas,601 :: 		IPEN_bit = ENABLE  ' Enable priority levels on interrupts
	BSF         IPEN_bit+0, BitPos(IPEN_bit+0) 
;ballisticchronograph.mbas,602 :: 		GIEH_bit = ENABLE  ' all high priority interrupts
	BSF         GIEH_bit+0, BitPos(GIEH_bit+0) 
;ballisticchronograph.mbas,603 :: 		GIEL_bit = ENABLE  ' all low  priority interrupts
	BSF         GIEL_bit+0, BitPos(GIEL_bit+0) 
;ballisticchronograph.mbas,606 :: 		if sw_test(3) = SW_ON then
	MOVLW       3
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main249
;ballisticchronograph.mbas,607 :: 		LED1_PORT = LED_ON
	BSF         LATB+0, 6 
;ballisticchronograph.mbas,608 :: 		screen_distance_mm = input_number( 4, screen_distance_mm )
	MOVLW       4
	MOVWF       FARG_input_number_digit_number+0 
	MOVF        _screen_distance_mm+0, 0 
	MOVWF       FARG_input_number_initial+0 
	MOVF        _screen_distance_mm+1, 0 
	MOVWF       FARG_input_number_initial+1 
	CALL        _input_number+0, 0
	MOVF        R0, 0 
	MOVWF       _screen_distance_mm+0 
	MOVF        R1, 0 
	MOVWF       _screen_distance_mm+1 
;ballisticchronograph.mbas,609 :: 		if screen_distance_mm = 0 then
	MOVLW       0
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main356
	MOVLW       0
	XORWF       R0, 0 
L__main356:
	BTFSS       STATUS+0, 2 
	GOTO        L__main252
;ballisticchronograph.mbas,610 :: 		screen_distance_mm = DEFAULT_SCREEN_DISTANCE
	MOVLW       44
	MOVWF       _screen_distance_mm+0 
	MOVLW       1
	MOVWF       _screen_distance_mm+1 
L__main252:
;ballisticchronograph.mbas,612 :: 		display_message( MSG_SAVE )
	MOVLW       3
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,613 :: 		eeprom_write( EEPADDR_DISTANCE,   screen_distance_mm mod 0x100 )
	CLRF        FARG_EEPROM_Write_address+0 
	MOVLW       255
	ANDWF       _screen_distance_mm+0, 0 
	MOVWF       R0 
	MOVF        _screen_distance_mm+1, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,614 :: 		eeprom_write( EEPADDR_DISTANCE+1, screen_distance_mm  /  0x100 )
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _screen_distance_mm+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,615 :: 		delay_ms( 1000 )
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L__main254:
	DECFSZ      R13, 1, 1
	BRA         L__main254
	DECFSZ      R12, 1, 1
	BRA         L__main254
	DECFSZ      R11, 1, 1
	BRA         L__main254
	NOP
;ballisticchronograph.mbas,616 :: 		LED1_PORT = LED_OFF
	BCF         LATB+0, 6 
L__main249:
;ballisticchronograph.mbas,619 :: 		display_velocity_unit( velocity_unit )
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_display_velocity_unit_velocity_unit+0 
	CALL        _display_velocity_unit+0, 0
;ballisticchronograph.mbas,620 :: 		display_number( screen_distance_mm )
	MOVF        _screen_distance_mm+0, 0 
	MOVWF       FARG_display_number_num+0 
	MOVF        _screen_distance_mm+1, 0 
	MOVWF       FARG_display_number_num+1 
	CALL        _display_number+0, 0
;ballisticchronograph.mbas,621 :: 		delay_ms(1000)
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L__main255:
	DECFSZ      R13, 1, 1
	BRA         L__main255
	DECFSZ      R12, 1, 1
	BRA         L__main255
	DECFSZ      R11, 1, 1
	BRA         L__main255
	NOP
;ballisticchronograph.mbas,623 :: 		interval_counter      = 0
	CLRF        _interval_counter+0 
	CLRF        _interval_counter+1 
	CLRF        _interval_counter+2 
	CLRF        _interval_counter+3 
;ballisticchronograph.mbas,624 :: 		interval_counter_prev = 0
	CLRF        _interval_counter_prev+0 
	CLRF        _interval_counter_prev+1 
	CLRF        _interval_counter_prev+2 
	CLRF        _interval_counter_prev+3 
;ballisticchronograph.mbas,625 :: 		shot_number = 0
	CLRF        _shot_number+0 
	CLRF        _shot_number+1 
;ballisticchronograph.mbas,626 :: 		display_message( MSG_READY )
	MOVLW       1
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,627 :: 		reset_screen()
	CALL        _reset_screen+0, 0
;ballisticchronograph.mbas,628 :: 		while true
L__main257:
;ballisticchronograph.mbas,630 :: 		if screen_timeout then
	MOVF        _screen_timeout+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main262
;ballisticchronograph.mbas,631 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,632 :: 		if not serial_out_mode then
	COMF        _serial_out_mode+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main265
;ballisticchronograph.mbas,633 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,634 :: 		delay_ms(200)
	MOVLW       17
	MOVWF       R11, 0
	MOVLW       60
	MOVWF       R12, 0
	MOVLW       203
	MOVWF       R13, 0
L__main267:
	DECFSZ      R13, 1, 1
	BRA         L__main267
	DECFSZ      R12, 1, 1
	BRA         L__main267
	DECFSZ      R11, 1, 1
	BRA         L__main267
L__main265:
;ballisticchronograph.mbas,636 :: 		display_message( ERROR_SCREEN_1ST )
	MOVLW       2
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,637 :: 		delay_ms(1)
	MOVLW       21
	MOVWF       R12, 0
	MOVLW       198
	MOVWF       R13, 0
L__main268:
	DECFSZ      R13, 1, 1
	BRA         L__main268
	DECFSZ      R12, 1, 1
	BRA         L__main268
	NOP
;ballisticchronograph.mbas,638 :: 		shot_number = shot_number + 1
	INFSNZ      _shot_number+0, 1 
	INCF        _shot_number+1, 1 
;ballisticchronograph.mbas,639 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main262:
;ballisticchronograph.mbas,643 :: 		if pulse_error then
	MOVF        _pulse_error+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main270
;ballisticchronograph.mbas,644 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,645 :: 		if not serial_out_mode then
	COMF        _serial_out_mode+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main273
;ballisticchronograph.mbas,646 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,647 :: 		delay_ms(200)
	MOVLW       17
	MOVWF       R11, 0
	MOVLW       60
	MOVWF       R12, 0
	MOVLW       203
	MOVWF       R13, 0
L__main275:
	DECFSZ      R13, 1, 1
	BRA         L__main275
	DECFSZ      R12, 1, 1
	BRA         L__main275
	DECFSZ      R11, 1, 1
	BRA         L__main275
L__main273:
;ballisticchronograph.mbas,649 :: 		display_message( ERROR_PULSE )
	MOVLW       6
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,650 :: 		delay_ms(1)
	MOVLW       21
	MOVWF       R12, 0
	MOVLW       198
	MOVWF       R13, 0
L__main276:
	DECFSZ      R13, 1, 1
	BRA         L__main276
	DECFSZ      R12, 1, 1
	BRA         L__main276
	NOP
;ballisticchronograph.mbas,651 :: 		shot_number = shot_number + 1
	INFSNZ      _shot_number+0, 1 
	INCF        _shot_number+1, 1 
;ballisticchronograph.mbas,652 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main270:
;ballisticchronograph.mbas,656 :: 		if screen2nd_detect = true then
	MOVF        _screen2nd_detect+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L__main278
;ballisticchronograph.mbas,657 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,658 :: 		shot_number = shot_number + 1
	INFSNZ      _shot_number+0, 1 
	INCF        _shot_number+1, 1 
;ballisticchronograph.mbas,659 :: 		velocity = calc_velocity_mps( tmr1H_save * 0x100 + tmr1L_save, tmr1_oveflow_count_save, screen_distance_mm )
	MOVF        _tmr1H_save+0, 0 
	MOVWF       FARG_calc_velocity_mps_tmr_value+1 
	CLRF        FARG_calc_velocity_mps_tmr_value+0 
	MOVF        _tmr1L_save+0, 0 
	ADDWF       FARG_calc_velocity_mps_tmr_value+0, 1 
	MOVLW       0
	ADDWFC      FARG_calc_velocity_mps_tmr_value+1, 1 
	MOVF        _tmr1_oveflow_count_save+0, 0 
	MOVWF       FARG_calc_velocity_mps_overflow+0 
	MOVF        _screen_distance_mm+0, 0 
	MOVWF       FARG_calc_velocity_mps_screen_distance+0 
	MOVF        _screen_distance_mm+1, 0 
	MOVWF       FARG_calc_velocity_mps_screen_distance+1 
	CALL        _calc_velocity_mps+0, 0
	MOVF        R0, 0 
	MOVWF       main_velocity+0 
	MOVF        R1, 0 
	MOVWF       main_velocity+1 
	MOVF        R2, 0 
	MOVWF       main_velocity+2 
	MOVF        R3, 0 
	MOVWF       main_velocity+3 
;ballisticchronograph.mbas,660 :: 		if 9999 < velocity then
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVLW       0
	MOVWF       R0 
	MOVLW       60
	MOVWF       R1 
	MOVLW       28
	MOVWF       R2 
	MOVLW       140
	MOVWF       R3 
	CALL        _Compare_Double+0, 0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main281
;ballisticchronograph.mbas,661 :: 		if not serial_out_mode then
	COMF        _serial_out_mode+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main284
;ballisticchronograph.mbas,662 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,663 :: 		delay_ms(300)
	MOVLW       25
	MOVWF       R11, 0
	MOVLW       90
	MOVWF       R12, 0
	MOVLW       177
	MOVWF       R13, 0
L__main286:
	DECFSZ      R13, 1, 1
	BRA         L__main286
	DECFSZ      R12, 1, 1
	BRA         L__main286
	DECFSZ      R11, 1, 1
	BRA         L__main286
	NOP
	NOP
L__main284:
;ballisticchronograph.mbas,665 :: 		display_message( ERROR_FAST )
	MOVLW       4
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,666 :: 		delay_ms(1)
	MOVLW       21
	MOVWF       R12, 0
	MOVLW       198
	MOVWF       R13, 0
L__main287:
	DECFSZ      R13, 1, 1
	BRA         L__main287
	DECFSZ      R12, 1, 1
	BRA         L__main287
	NOP
	GOTO        L__main282
;ballisticchronograph.mbas,667 :: 		else
L__main281:
;ballisticchronograph.mbas,668 :: 		if not serial_out_mode then
	COMF        _serial_out_mode+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L__main289
;ballisticchronograph.mbas,669 :: 		clear_display()
	CALL        _clear_display+0, 0
;ballisticchronograph.mbas,670 :: 		delay_ms(300)
	MOVLW       25
	MOVWF       R11, 0
	MOVLW       90
	MOVWF       R12, 0
	MOVLW       177
	MOVWF       R13, 0
L__main291:
	DECFSZ      R13, 1, 1
	BRA         L__main291
	DECFSZ      R12, 1, 1
	BRA         L__main291
	DECFSZ      R11, 1, 1
	BRA         L__main291
	NOP
	NOP
L__main289:
;ballisticchronograph.mbas,672 :: 		display_velocity( velocity, velocity_unit )
	MOVF        main_velocity+0, 0 
	MOVWF       FARG_display_velocity_velocity+0 
	MOVF        main_velocity+1, 0 
	MOVWF       FARG_display_velocity_velocity+1 
	MOVF        main_velocity+2, 0 
	MOVWF       FARG_display_velocity_velocity+2 
	MOVF        main_velocity+3, 0 
	MOVWF       FARG_display_velocity_velocity+3 
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_display_velocity_unit+0 
	CALL        _display_velocity+0, 0
;ballisticchronograph.mbas,673 :: 		FloatToStr( velocity, tx_string )
	MOVF        main_velocity+0, 0 
	MOVWF       FARG_FloatToStr_input+0 
	MOVF        main_velocity+1, 0 
	MOVWF       FARG_FloatToStr_input+1 
	MOVF        main_velocity+2, 0 
	MOVWF       FARG_FloatToStr_input+2 
	MOVF        main_velocity+3, 0 
	MOVWF       FARG_FloatToStr_input+3 
	MOVLW       main_tx_string+0
	MOVWF       FARG_FloatToStr_output+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_FloatToStr_output+1 
	CALL        _FloatToStr+0, 0
;ballisticchronograph.mbas,674 :: 		if serial_out_mode then
	MOVF        _serial_out_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main293
;ballisticchronograph.mbas,675 :: 		LED4_PORT = 0
	BCF         LATC+0, 2 
	GOTO        L__main294
;ballisticchronograph.mbas,676 :: 		else
L__main293:
;ballisticchronograph.mbas,677 :: 		LED4_PORT = 1
	BSF         LATC+0, 2 
;ballisticchronograph.mbas,678 :: 		end if
L__main294:
;ballisticchronograph.mbas,679 :: 		UART_Write_Text( tx_string )
	MOVLW       main_tx_string+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;ballisticchronograph.mbas,680 :: 		UART_Write_Text( "," )
	MOVLW       44
	MOVWF       ?LocalText_main+0 
	CLRF        ?LocalText_main+1 
	MOVLW       ?LocalText_main+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(?LocalText_main+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;ballisticchronograph.mbas,681 :: 		if interval_counter_prev = 0 then
	MOVLW       0
	MOVWF       R0 
	XORWF       _interval_counter_prev+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main357
	MOVF        R0, 0 
	XORWF       _interval_counter_prev+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main357
	MOVF        R0, 0 
	XORWF       _interval_counter_prev+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main357
	MOVF        _interval_counter_prev+0, 0 
	XORLW       0
L__main357:
	BTFSS       STATUS+0, 2 
	GOTO        L__main296
;ballisticchronograph.mbas,682 :: 		LongwordToStr( 0, tx_string )
	CLRF        FARG_LongWordToStr_input+0 
	CLRF        FARG_LongWordToStr_input+1 
	CLRF        FARG_LongWordToStr_input+2 
	CLRF        FARG_LongWordToStr_input+3 
	MOVLW       main_tx_string+0
	MOVWF       FARG_LongWordToStr_output+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_LongWordToStr_output+1 
	CALL        _LongWordToStr+0, 0
	GOTO        L__main297
;ballisticchronograph.mbas,683 :: 		else
L__main296:
;ballisticchronograph.mbas,684 :: 		LongwordToStr( interval_counter - interval_counter_prev, tx_string )
	MOVF        _interval_counter+0, 0 
	MOVWF       FARG_LongWordToStr_input+0 
	MOVF        _interval_counter+1, 0 
	MOVWF       FARG_LongWordToStr_input+1 
	MOVF        _interval_counter+2, 0 
	MOVWF       FARG_LongWordToStr_input+2 
	MOVF        _interval_counter+3, 0 
	MOVWF       FARG_LongWordToStr_input+3 
	MOVF        _interval_counter_prev+0, 0 
	SUBWF       FARG_LongWordToStr_input+0, 1 
	MOVF        _interval_counter_prev+1, 0 
	SUBWFB      FARG_LongWordToStr_input+1, 1 
	MOVF        _interval_counter_prev+2, 0 
	SUBWFB      FARG_LongWordToStr_input+2, 1 
	MOVF        _interval_counter_prev+3, 0 
	SUBWFB      FARG_LongWordToStr_input+3, 1 
	MOVLW       main_tx_string+0
	MOVWF       FARG_LongWordToStr_output+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_LongWordToStr_output+1 
	CALL        _LongWordToStr+0, 0
;ballisticchronograph.mbas,685 :: 		end if
L__main297:
;ballisticchronograph.mbas,686 :: 		UART_Write_Text( tx_string )
	MOVLW       main_tx_string+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;ballisticchronograph.mbas,687 :: 		UART_Write_Text( "," )
	MOVLW       44
	MOVWF       ?LocalText_main+0 
	CLRF        ?LocalText_main+1 
	MOVLW       ?LocalText_main+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(?LocalText_main+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;ballisticchronograph.mbas,688 :: 		WordToStr( shot_number, tx_string )
	MOVF        _shot_number+0, 0 
	MOVWF       FARG_WordToStr_input+0 
	MOVF        _shot_number+1, 0 
	MOVWF       FARG_WordToStr_input+1 
	MOVLW       main_tx_string+0
	MOVWF       FARG_WordToStr_output+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_WordToStr_output+1 
	CALL        _WordToStr+0, 0
;ballisticchronograph.mbas,689 :: 		UART_Write_Text( tx_string )
	MOVLW       main_tx_string+0
	MOVWF       FARG_UART_Write_Text_uart_text+0 
	MOVLW       hi_addr(main_tx_string+0)
	MOVWF       FARG_UART_Write_Text_uart_text+1 
	CALL        _UART_Write_Text+0, 0
;ballisticchronograph.mbas,690 :: 		UART_Write(10) ' CR
	MOVLW       10
	MOVWF       FARG_UART_Write_data_+0 
	CALL        _UART_Write+0, 0
;ballisticchronograph.mbas,691 :: 		if serial_out_mode then
	MOVF        _serial_out_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main299
;ballisticchronograph.mbas,692 :: 		LED4_PORT = 1
	BSF         LATC+0, 2 
	GOTO        L__main300
;ballisticchronograph.mbas,693 :: 		else
L__main299:
;ballisticchronograph.mbas,694 :: 		LED4_PORT = 0
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,695 :: 		end if
L__main300:
;ballisticchronograph.mbas,696 :: 		current_status = STATUS_NORMAL
	CLRF        _current_status+0 
;ballisticchronograph.mbas,697 :: 		end if
L__main282:
;ballisticchronograph.mbas,698 :: 		interval_counter_prev = interval_counter
	MOVF        _interval_counter+0, 0 
	MOVWF       _interval_counter_prev+0 
	MOVF        _interval_counter+1, 0 
	MOVWF       _interval_counter_prev+1 
	MOVF        _interval_counter+2, 0 
	MOVWF       _interval_counter_prev+2 
	MOVF        _interval_counter+3, 0 
	MOVWF       _interval_counter_prev+3 
;ballisticchronograph.mbas,699 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main278:
;ballisticchronograph.mbas,703 :: 		if sw_test(3) = SW_ON then
	MOVLW       3
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main302
;ballisticchronograph.mbas,704 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,705 :: 		if shotgun_mode then
	MOVF        _shotgun_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main305
;ballisticchronograph.mbas,706 :: 		shotgun_mode = False
	CLRF        _shotgun_mode+0 
	GOTO        L__main306
;ballisticchronograph.mbas,707 :: 		else
L__main305:
;ballisticchronograph.mbas,708 :: 		shotgun_mode = True
	MOVLW       255
	MOVWF       _shotgun_mode+0 
;ballisticchronograph.mbas,709 :: 		serial_out_mode = False
	CLRF        _serial_out_mode+0 
;ballisticchronograph.mbas,710 :: 		LED4_PORT = 0
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,711 :: 		end if
L__main306:
;ballisticchronograph.mbas,712 :: 		if current_status = STATUS_NORMAL then
	MOVF        _current_status+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main308
;ballisticchronograph.mbas,713 :: 		display_velocity( velocity, velocity_unit )
	MOVF        main_velocity+0, 0 
	MOVWF       FARG_display_velocity_velocity+0 
	MOVF        main_velocity+1, 0 
	MOVWF       FARG_display_velocity_velocity+1 
	MOVF        main_velocity+2, 0 
	MOVWF       FARG_display_velocity_velocity+2 
	MOVF        main_velocity+3, 0 
	MOVWF       FARG_display_velocity_velocity+3 
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_display_velocity_unit+0 
	CALL        _display_velocity+0, 0
	GOTO        L__main309
;ballisticchronograph.mbas,714 :: 		else
L__main308:
;ballisticchronograph.mbas,715 :: 		display_message( current_status )
	MOVF        _current_status+0, 0 
	MOVWF       FARG_display_message_error_code+0 
	CALL        _display_message+0, 0
;ballisticchronograph.mbas,716 :: 		end if
L__main309:
;ballisticchronograph.mbas,717 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main302:
;ballisticchronograph.mbas,721 :: 		if sw_test(1) = SW_ON then
	MOVLW       1
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main311
;ballisticchronograph.mbas,722 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,724 :: 		case VELOCITY_MPS velocity_unit = VELOCITY_KPH
	MOVF        _velocity_unit+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__main316
	MOVLW       2
	MOVWF       _velocity_unit+0 
	GOTO        L__main313
L__main316:
;ballisticchronograph.mbas,725 :: 		case VELOCITY_KPH velocity_unit = VELOCITY_FPS
	MOVF        _velocity_unit+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__main319
	MOVLW       3
	MOVWF       _velocity_unit+0 
	GOTO        L__main313
L__main319:
;ballisticchronograph.mbas,726 :: 		case VELOCITY_FPS velocity_unit = VELOCITY_MPS
	MOVF        _velocity_unit+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__main322
	MOVLW       1
	MOVWF       _velocity_unit+0 
	GOTO        L__main313
L__main322:
L__main313:
;ballisticchronograph.mbas,728 :: 		display_velocity_unit( velocity_unit )
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_display_velocity_unit_velocity_unit+0 
	CALL        _display_velocity_unit+0, 0
;ballisticchronograph.mbas,729 :: 		if current_status = STATUS_NORMAL then
	MOVF        _current_status+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main324
;ballisticchronograph.mbas,730 :: 		display_velocity( velocity, velocity_unit )
	MOVF        main_velocity+0, 0 
	MOVWF       FARG_display_velocity_velocity+0 
	MOVF        main_velocity+1, 0 
	MOVWF       FARG_display_velocity_velocity+1 
	MOVF        main_velocity+2, 0 
	MOVWF       FARG_display_velocity_velocity+2 
	MOVF        main_velocity+3, 0 
	MOVWF       FARG_display_velocity_velocity+3 
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_display_velocity_unit+0 
	CALL        _display_velocity+0, 0
L__main324:
;ballisticchronograph.mbas,732 :: 		eeprom_write( EEPADDR_VELOCITY_UNIT, velocity_unit )
	MOVLW       2
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _velocity_unit+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,733 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main311:
;ballisticchronograph.mbas,737 :: 		if sw_test(2) = SW_ON then
	MOVLW       2
	MOVWF       FARG_sw_test_sw_no+0 
	CALL        _sw_test+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main327
;ballisticchronograph.mbas,738 :: 		disable_screen()
	CALL        _disable_screen+0, 0
;ballisticchronograph.mbas,739 :: 		if serial_out_mode then
	MOVF        _serial_out_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main330
;ballisticchronograph.mbas,740 :: 		serial_out_mode = False
	CLRF        _serial_out_mode+0 
	GOTO        L__main331
;ballisticchronograph.mbas,741 :: 		else
L__main330:
;ballisticchronograph.mbas,742 :: 		serial_out_mode = True
	MOVLW       255
	MOVWF       _serial_out_mode+0 
;ballisticchronograph.mbas,743 :: 		end if
L__main331:
;ballisticchronograph.mbas,744 :: 		eeprom_write( EEPADDR_SERIAL_OUT_MODE, serial_out_mode )
	MOVLW       3
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _serial_out_mode+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;ballisticchronograph.mbas,745 :: 		if serial_out_mode then
	MOVF        _serial_out_mode+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main333
;ballisticchronograph.mbas,746 :: 		LED4_PORT = 1
	BSF         LATC+0, 2 
	GOTO        L__main334
;ballisticchronograph.mbas,747 :: 		else
L__main333:
;ballisticchronograph.mbas,748 :: 		LED4_PORT = 0
	BCF         LATC+0, 2 
;ballisticchronograph.mbas,749 :: 		end if
L__main334:
;ballisticchronograph.mbas,750 :: 		reset_screen()
	CALL        _reset_screen+0, 0
L__main327:
;ballisticchronograph.mbas,752 :: 		wend
	GOTO        L__main257
L_end_main:
	GOTO        $+0
; end of _main
